function [ F_2D_3GPP ] = c_F_3GPP( phi, phi_3dB, Am, AntGain_dB, phi0 )
%% cumulative function for 3GPP directivity pattern
%assuming $ phi_3dB * sqrt(Am/12) < phi0$, otherwise the first and last
%branches are not needed


F_2D_3GPP = zeros(size(phi));
for j = 1 : length(phi)
    phi_j = phi(j);
    
   if  phi_j <= - phi_3dB * sqrt(Am/12)
       F_2D_3GPP(j) = (phi_j + phi0) * 10^(-Am/20) ;
   elseif  phi_j <= 0
       F_2D_3GPP(j) = (-phi_3dB * sqrt(Am/12) + phi0) * 10^(-Am/20)  + 0.5*sqrt(pi * phi_3dB^2/(log(10) * 0.6))*(erf(sqrt(log(10) * 0.6 * Am / 12)) ...
           -erf(sqrt(log(10) * 0.6 / (phi_3dB^2)) * (- phi_j)));
   elseif phi_j <= phi_3dB * sqrt(Am/12)
       F_2D_3GPP(j) = (-phi_3dB * sqrt(Am/12) + phi0) * 10^(-Am/20)  + 0.5*sqrt(pi * phi_3dB^2/(log(10) * 0.6))*(erf(sqrt(log(10) * 0.6 * Am / 12)) ...
           +erf(sqrt(log(10) * 0.6  / (phi_3dB^2)) * (phi_j)));
   else
       F_2D_3GPP(j) = (-phi_3dB * sqrt(Am/12) + phi0) * 10^(-Am/20)  +  sqrt(pi * phi_3dB^2/(log(10) * 0.6))*(erf(sqrt(log(10) * 0.6 * Am / 12))) ...
           + (phi_j - phi_3dB * sqrt(Am/12))* 10^(-Am/20);
   end
end
F_2D_3GPP = F_2D_3GPP * 10^(AntGain_dB/20);
end

