function [ c_F_inv_3GPP ] = c_F_3GPP_inv(   c_F_3GPP, phi_3dB, Am  , AntGain_dB, phi0 ) 

%% inverse cumulative function for 3GPP directivity pattern
%assuming $phi0 >= phi_3dB * sqrt(Am/12)$, otherwise the first and last
%branches are not needed

c_F_inv_3GPP = zeros(size(c_F_3GPP));


%  point at whicjh inverse function changes
y1 =  (phi0 - phi_3dB * sqrt(Am/12)) * 10^(-Am/20) ;
y2 =  ( (phi0 - phi_3dB * sqrt(Am/12)) * 10^(-Am/20) +  0.5*sqrt(pi * phi_3dB^2/(log(10) * 0.6))*(erf(sqrt(log(10) * 0.6 * Am / 12))));
y3 =  ((phi0 - phi_3dB * sqrt(Am/12)) * 10^(-Am/20) +  sqrt(pi * phi_3dB^2/(log(10) * 0.6))*(erf(sqrt(log(10) * 0.6 * Am / 12))));


for j = 1 : length(c_F_3GPP)
    y_j = c_F_3GPP(j)*10^(-AntGain_dB/20);
    
    if y_j <= y1
       c_F_inv_3GPP(j) = y_j*10^(Am/20)    - phi0;
    elseif y_j <= y2
       c_F_inv_3GPP(j) = -(1/sqrt(log(10) * 0.6 / (phi_3dB^2)) ) * erfinv(-(2/sqrt(pi * phi_3dB^2/(log(10) * 0.6)))* (y_j   - y2) );
    elseif y_j <= y3
        c_F_inv_3GPP(j) = (1/sqrt(log(10) * 0.6 / (phi_3dB^2)) ) * erfinv((2/sqrt(pi * phi_3dB^2/(log(10) * 0.6)))*(y_j  - y2));
    else
        c_F_inv_3GPP(j) = (y_j  -  y3)*10^(Am/20)  +  phi_3dB * sqrt(Am/12) ;
    end
    
end

end

