function [ x_est ] = Quantize_Lloyd( x, B_q )


epsilon = 1e-8;
if size(x,1) == 1
    %process real part
    x_real = real(x(:));
    MAX_x_real = max(x_real)+epsilon/2;
    min_x_real = min(x_real)-epsilon/2;
    %process imag part
    x_imag = imag(x(:));
    MAX_x_imag = max(x_imag)+epsilon/2;
    min_x_imag = min(x_imag)-epsilon/2;
    
else
    %process real part
    x_real = real(x(:));
    MAX_x_real = max(x_real);
    min_x_real = min(x_real);
    
    %process imag part
    x_imag = imag(x(:));
    MAX_x_imag = max(x_imag);
    min_x_imag = min(x_imag);
    
end
%real part
dyn_range_x_real = MAX_x_real - min_x_real;
step_real = dyn_range_x_real / (2^B_q);
codebook_x_real = [min_x_real  :  step_real :  MAX_x_real];
% Now optimize, using codebook as an initial guess.
[partition_x_real,codebook_x_real] = lloyds(x_real, codebook_x_real);
[~,x_est_real,~] = quantiz(x_real, partition_x_real, codebook_x_real);

%imaginary part
dyn_range_x_imag = MAX_x_imag - min_x_imag;
step_imag = dyn_range_x_imag / (2^B_q);
codebook_x_imag = [min_x_imag  :  step_imag :  MAX_x_imag];

% Now optimize, using codebook as an initial guess.
[partition_x_imag,codebook_x_imag] = lloyds(x_imag,codebook_x_imag);
[~,x_est_imag,~] = quantiz(x_imag, partition_x_imag, codebook_x_imag);
 
% x_est = x_est_real + 1i*x_est_imag;
x_est = reshape( x_est_real + 1i*x_est_imag, size(x));
end