function [ F_2D_dipole ] = c_F_dipole( phi , G_m, a)


%% dipole directivity pattern cumulative function

F_2D_dipole = zeros(size(phi));


y1 = (G_m/12) *( 12 *sin(a) - 4*sin(a).^3 + 8 );
y2 = (G_m/12) *( 12 *sin(-pi/2) - 4*sin(-pi/2).^3 + 8 );
y3 =  (G_m/12) *( 12 *sin(pi/2) - 4*sin(pi/2).^3 + 8 );



for j = 1 : length(phi)
    phi_j = phi(j);
    if phi(j)<-pi/2
         F_2D_dipole(j) =  -(G_m/12) *( 12 *sin(phi_j) - 4*sin(phi_j).^3 + 8 ) + y1;
    elseif phi(j)<=pi/2 && phi(j)>=-pi/2
        F_2D_dipole(j) = (y2 + y1) + (G_m/12) *( 12 *sin(phi_j) - 4*sin(phi_j).^3 + 8 );
    else
         F_2D_dipole(j) =  2*y3  +  y1 -  (G_m/12) *( 12 *sin(phi_j) - 4*sin(phi_j).^3 + 8 ) ;
    end
    F_2D_dipole(j) = F_2D_dipole(j)  ;
end

