function [ F_2D_dipole_inv ] = c_F_dipole_inv_v2( y, G_m  , a )


%% dipole directivity pattern inverse cumulative function

y1 = (G_m/12) *( 12 *sin(a) - 4*sin(a).^3 + 8 );
y3 =  (G_m/12) *( 12 *sin(pi/2) - 4*sin(pi/2).^3 + 8 );

F_2D_dipole_inv = zeros(size(y));

for j = 1 : length(y)
    y_j = y(j);
    
    if y_j <= y1
        D0 =  9;
        D1 =  -(27*(2  + (3/G_m)*(y_j-y1)));
        C = (0.5*(D1 + sqrt(D1.^2 - 4*D0^3))).^(1/3);
        i2 = (-1 + 1i*sqrt(3))/2;
        i3 = conj(i2);
        F_2D_dipole_inv(j) = real(asin((1/(3)) * (i3*C + D0./(i3*C)))) -pi  ;
    elseif  y_j <= y3  +y1
        D0 =  9;
        D1 =  -(27*(2  - (3/G_m)*(y_j  - y1)));
        C = (0.5*(D1 + sqrt(D1.^2 - 4*D0^3))).^(1/3);
        i2 = (-1 + 1i*sqrt(3))/2;
        i3 = conj(i2);
        F_2D_dipole_inv(j) =  real(asin(-(1/(3)) * (i3*C + D0./(i3*C)))) ;
    else
        D0 =   9;
        D1 = -(27*(2  + (3/G_m)*(y_j - 2*y3 - y1)));
        C = (0.5*(D1 + sqrt(D1.^2 - 4*D0^3))).^(1/3);
        i2 = (-1 + 1i*sqrt(3))/2;
        i3 = conj(i2);
        F_2D_dipole_inv(j) =  real(asin((1/(3)) * (i3*C + D0./(i3*C)))) +pi  ;
    end
    
end


end


